% mclr.tex $ this file belongs to the Molcas repository $

\section{\program{mclr}}
\label{UG:sec:mclr}
\index{Program!mclr@\program{mclr}}\index{mclr@\program{mclr}}
%%%<MODULE NAME="MCLR">
%%Description:
%%%<HELP>
%%+This program calculates the response of a SCF or MCSCF wave function
%%+and related second order properties.
%%%</HELP>

The \program{mclr} program in \molcas\ performs response calculations on
single and multiconfigurational SCF wave functions with the technique described
in \cite{Bernhardsson:99a}.
The right hand side (RHS) and thus the perturbation has to be defined through a preceding
\program{MCKINLEY} calculation. Second order derivatives are obtained from a \program{MCKINLEY} and
a consecutive \program{mclr} calculation, with a geometrical displacement as the external perturbation.
If the response of a geometrical perturbation is calculated, harmonic frequencies corresponding to
the most abundant masses are printed. \program{MCLR} also calculates isotope shifted frequencies.
Per default, vibrational frequencies are calculated for all possible single isotopic substitutions.
\program{MCLR} always calculates the response of an electric field and prints the polarizability.

Note that the user should not normally, for frequency calculations,
request the execution of this module since this will be automatic.

The \program{mclr} code also calculates the Lagrangian multipliers required for a
SA-MCSCF single state gradient \cite{Stalring:01a}, where the RHS is generated by the program itself.
Through an \program{mclr} and a consecutive \program{alaska} calculation, analytical gradients
of a SA-MCSCF state may be obtained. {\bf Note that \program{alaska} will automatically run the \program{mclr} module!}
Thus, with \program{slapaf} geometry optimizations of
excited MCSCF states can be performed.

The \program{MCLR} program is based on the split GUGA formalism.
However, it uses determinant based algorithms to solve the configuration
interaction problem \cite{rasdet}, in analogy to how it is done in the  \program{RASSCF}.
For spin symmetric wave function ($M_S=0$) the time reversal symmetry is used, and the innermost loops are performed in
combinations instead of determinant.

The upper limit to the size of the CI wave function that can be
handled with the present program is about  the same as for the \program{RASSCF}.
The present version of the code is just able to handle CASSCF wave function, RASSCF
wave function will soon be included.

The orbital handling is based on a one index transformation technique.
The integrals is the transformed to occupied orbitals in two indexes,
this can be done directly or from disk based integrals generated by \program{seward}.


\subsection{Dependencies}
\label{UG:sec:mclr_dependencies}
To start the \program{MCLR} module the one{-}electron integrals generated by
\program{SEWARD} have to be available. Moreover, \program{MCLR} requires
the wave function from a \program{SCF} or \program{RASSCF} calculation and
apart from in an evaluation of SA-MCSCF gradients, it also requires the differentiated integrals
from \program{MCKINLEY}.

\subsection{Files}
\label{UG:sec:mclr_files}

\subsubsection{Input files}
\label{UG:sec:mclr_input_files}
\program{MCLR} will use the following input
files: \file{ONEINT}, \file{ORDINT},\file{RUNFILE}, \file{ABDATA},
\file{RYSRW}, \file{JOBIPH}
(for more information see~\ref{UG:sec:files_list}).


\subsubsection{Output files}
\label{UG:sec:mclr_output_files}

\begin{filelist}
\item[MCKINT]
Communication file between \program{mclr} and \program{mckinley} and \program{rassi}
\item[UNSYM]
ASCII file where all essential information, like geometry, Hessian normal modes and dipole
derivatives are stored.
\item[MLDNFQ]
Molden input file for harmonic frequency analysis.
\end{filelist}

\subsubsection{Scratch files}
\label{UG:sec:mclr_scratch_files}
\begin{filelist}
\item[TEMP0x]
x=1,8 used for for integral transformation and storing half transformed integrals.
\item[REORD]
Used for storing data used in the transformation of CI vectors from determinant base to CSF base.
\item[TEMPCIV]
Exchange file for temporary storing the CI vectors during the PCG.
\item[RESP]
Binary file where the solution of the response equations are stored.
\item[JOPR]
Used for half transformed integrals in direct mode.
\item[KOPR]
Used for half transformed integrals in direct mode.
\end{filelist}


\subsection{Input}
\label{UG:sec:mclr_input}

This section describes the input to the
\program{MCLR} program in the \molcas\ program system.
The input for each module is preceded by its name like:
\begin{inputlisting}
 &MCLR
\end{inputlisting}


\subsubsection{Optional keywords}

A list of these keywords is given below:
\begin{keywordlist}
\item[SALA]
%%%<KEYWORD MODULE="MCLR" NAME="SALA" APPEAR="SA-CASSCF Lagrangian: root selection" KIND="INT" LEVEL="BASIC">
%%%<HELP>
%%+Makes MCLR compute the Lagrangian multipliers for the specified root in a state average
%%+CASSCF wave function.
%%%</HELP>
%%%</KEYWORD>
%%Keyword: Sala <basic>
%%+Makes MCLR compute the Lagrangian multipliers for a state average
%%+MCSCF wave function. These multipliers are required by ALASKA
%%+to obtain analytical gradients for an excited state, when the excited
%%+state is determined by a SA optimization. SALA has
%%+to be followed by an integer on the next line, specifying the
%%+excited state for which the gradient is required.
Makes \program{MCLR} compute the Lagrangian multipliers for a state average
MCSCF wave function. These multipliers are required by \program{ALASKA}
to obtain analytical gradients for an excited state, when the excited
state is determined by a SA optimization. \keyword{SALA} has
to be followed by an integer on the next line, specifying the
excited state for which the gradient is required.
%-----
\item[NAC]
%%%<KEYWORD MODULE="MCLR" NAME="NAC" APPEAR="Nonadiabatic coupling: root selection" KIND="INTS" SIZE="2" LEVEL="BASIC">
%%%<HELP>
%%+Makes MCLR compute the Lagrangian multipliers for the nonadiabatic coupling
%%+between the specified roots in a state average CASSCF wave function.
%%%</HELP>
%%%</KEYWORD>
%%Keyword: NAC <basic>
%%+Makes MCLR compute the Lagrangian multipliers for a coupling
%%+in a state average MCSCF wave function. These multipliers are required by ALASKA
%%+to obtain analytical nonadiabatic couplings between states.
%%+NAC has to be followed by two integers on the next line, specifying the
%%+states between which the nonadiabatic coupling is required.
Like \keyword{SALA}, but for computing nonadiabatic couplings. It must
be followed by two integers on the next line, specifying the states
between which the coupling is required. Note that, unlike \keyword{SALA},
the numbering here is absolute, regardless of which roots are included
in the state average.
%-----
\item[EXPDimension]
%%%<KEYWORD MODULE="MCLR" NAME="EXPD" APPEAR="Explicit Hamiltonian dimension" KIND="INT" DEFAULT_VALUE="100" LEVEL="BASIC">
%%%<HELP>
%%+Specify the dimension of the explicit Hamiltonian used as preconditioner
%%+in the Preconditioned Conjugate Gradient algorithm.
%%%</HELP>
%%%</KEYWORD>
%%Keyword: EXPDimension <advanced>
%%+Here follows the dimension of the explicit Hamiltonian used as preconditioner
%%+in the Preconditioned conjugate gradient algorithm. Default 100.
Here follows the dimension of the explicit Hamiltonian used as preconditioner
in the Preconditioned conjugate gradient algorithm. Default 100.
%-----
\item[ITERations]
%%%<KEYWORD MODULE="MCLR" NAME="ITER" APPEAR="PCG Iterations" KIND="INT" DEFAULT_VALUE="200" LEVEL="BASIC">
%%Keyword: ITERations <advanced>
%%%<HELP>
%%+Specify the maximum number of iterations in the PCG. Default 200.
%%%</HELP>
%%%</KEYWORD>
Specify the maximum number of iterations in the PCG. Default 200.
%-----
\item[LOWMemory]
%%%<KEYWORD MODULE="MCLR" NAME="LOWM" APPEAR="Reduced memory usage" KIND="SINGLE"  LEVEL="ADVANCED">
%%Keyword: LOWMemory <advanced>
%%%<HELP>
%%+Lowers the amount of memory used, by paging out the CI vectors on disk.
%%+This will lower the performance, but the program will need less memory.
%%%</HELP>
%%%</KEYWORD>
Lowers the amount of memory used, by paging out the CI vectors on disk.
This will lower the performance, but the program will need less memory.
%-----
\item[PRINt]
%%%<KEYWORD MODULE="MCLR" NAME="PRINT" APPEAR="Print level" KIND="INT"  DEFAULT_VALUE="0" LEVEL="ADVANCED">
%%%<HELP>
%%+Specify the general print level with an integer (0-99).
%%%</HELP>
%%Keyword: PRINt <advanced>
%%+Raise the print level, default 0.
%%%</KEYWORD>
Raise the print level, default 0.
%-----
\item[RASSi]
%%Keyword: RASSi <advanced>
%%+This keyword is used for transforming the CI vectors to split GUGA
%%+representation, and transforming the orbital rotations to AO basis,
%%+to make the response accessible for state interaction calculations.
This keyword is used for transforming the CI vectors to split GUGA
representation, and transforming the orbital rotations to AO basis,
to make the response accessible for state interaction calculations.
\item[SEWArd]
%-----
%%Keyword: SEWArd <advanced>
%%+Specify one particle operators, used as right hand side, form the ONEINT
%%+file constructed by SEWARD.
%%+The keyword is followed by one row for each perturbation:
%%+LABEL symmetry Component
Specify one particle operators, used as right hand side, form the \file{ONEINT}
file constructed by \program{SEWARD}
The keyword is followed by one row for each perturbation:
LABEL symmetry Component
%-----
\item[EndSeward]
%%Keyword: EndSeward advanced
%%+Marks the end of perturbation specifications read from SEWARD ONEINT file.
Marks the end of perturbation specifications read from \program{SEWARD} \file{ONEINT} file.
%-----
\item[THREshold]
%%%<KEYWORD MODULE="MCLR" NAME="THRE" APPEAR="PCG Threshold" KIND="REAL" DEFAULT_VALUE="1.0D-4" LEVEL="BASIC">
%%Keyword: THREshold advanced
%%%<HELP>
%%+Specify the convergence threshold for the PCG. Default is 1.0e-4.
%%%</HELP>
%%%</KEYWORD>
Specify the convergence threshold for the PCG. Default is 1.0e{}-4.
%-----
\item[DISOTOPE]
%%%<KEYWORD MODULE="MCLR" NAME="DISO" APPEAR="Double isotopic substitutions" KIND="SINGLE" LEVEL="ADVANCED">
%%Keyword: DISOtope advanced
%%%<HELP>
%%+Calculates frequencies modified for double isotopic substitution.
%%%</HELP>
%%%</KEYWORD>
Calculates frequencies modified for double isotopic substitution.
%-----
\item[THERmochemistry]
%%%<KEYWORD MODULE="MCLR" NAME="THERMO" APPEAR="Thermochemistry" KIND="STRINGS" LEVEL="ADVANCED">
%%Keyword: THERM advanced
%%%<HELP>
%%+Request an user specified thermochemical analysis.
%%+The keyword is followed by the Rotational Symmetry Number,
%%+the Pressure (in atm), and lines containing the Temperatures (in K)
%%+for which the thermochemistry will be calculated.
%%+The section is ended by the keyword "End of PT".
%%%</HELP>
%%%</KEYWORD>
Request an user specified thermochemical analysis.
The keyword must be followed by a line containing the Rotational Symmetry Number,
a line containing the Pressure (in atm), and lines containing the Temperatures (in K)
for which the thermochemistry will be calculated. The section is ended by the
keyword "End of PT".

\item[TIME]
%%%<KEYWORD MODULE="MCLR" NAME="TIME" APPEAR="Time dep. response" KIND="REAL" LEVEL="ADVANCED">
%%%<HELP>
%%+Activate time dependent response of an electronic periodic perturbation
%%+and specify the frequency of the perturbation.
%%%</HELP>
%%%</KEYWORD>
%%Keyword: TIME advanced
%%+Calculates the time dependent response of an electric periodic perturbation.
%%+The frequency of the perturbation should be specified on the following line.
%%+Used to calculated time dependent polarizabilities and required in
%%+a RASSI calculation of two photon transition moments.
Calculates the time dependent response of an electric periodic perturbation.
The frequency of the perturbation should be specified on the following line.
Used to calculated time dependent polarizabilities and required in
a \program{RASSI} calculation of two photon transition moments.
%-----
\item[MASS]
%%Keyword: MASS advanced
%%+Used to generate single and double (in conjunction with DISO) isotope
%%+shifted frequencies, with the isotope masses specified by the user.
%%+This implementation can be useful for example in calculating
%%+intermolecular frequencies which are contaminated by the BSSE.
%%+By setting the corresponding masses to very large numbers, ghost orbitals
%%+can be used in the frequency calculation.
%%+MASS needs the atomic label and the new mass in units of u (real), for each element of the molecule.
Used to generate single and double (in conjunction with DISO) isotope
shifted frequencies, with the isotope masses specified by the user.
This implementation can be useful for example in calculating
intermolecular frequencies which are contaminated by the BSSE.
By setting the corresponding masses to very large numbers, ghost orbitals
can be used in the frequency calculation.
MASS needs the atomic label and the new mass in units of u (real), for each element of the molecule.
%---
\end{keywordlist}

\subsubsection{Input example}

A default input for a harmonic frequency calculation.

\begin{inputlisting}
 &MCLR
\end{inputlisting}

An input for a harmonic frequency calculation  with modified isotopic masses
for hydrogen and oxygen.

\begin{inputlisting}
 &MCLR
MASS
H   = 2.0079
O   = 150000.998
\end{inputlisting}

Thermochemistry for an asymmetric top (Rotational Symmetry Number
 = 1), at 1.0 atm and 273.15, 298.15, 398.15 and 498.15 K.
\begin{inputlisting}
 &MCLR
THERmochemistry
 1
 1.0
 273.15 ;  298.15 ;  398.15 ;  498.15
End of PT
\end{inputlisting}

The time dependent response is calculated for a perturbation of frequency
0.2 au.

\begin{inputlisting}
 &MCLR
TIME = 0.2
\end{inputlisting}
The time dependent response is calculated for a perturbation of frequency
0.2 au.

The input:
\begin{inputlisting}
 &MCLR
SALA  = 2
\end{inputlisting}
computes the Lagrangian multipliers for state number 2 in the SA root.
Note, that 2 refers to the SA root. Thus, if the ground state is not
included in the SA, the numbering of roots in the CI root and SA root
differ. With the following \program{RASSCF} input:
\begin{inputlisting}
 &RASSCF
CiRoot
 2 3
 2 3
 1 1
RlxRoot = 2
\end{inputlisting}
\keyword{SALA 2} yields the gradient for CI root number 3. Geometry optimization
of an excited SA-CASSCF state can be done normally using EMIL commands,
and requires the use of the \keyword{RLXR} keyword in the \program{RASSCF}
input to specify the selected root to be optimized. An explicit input
to \program{MCLR} is not required but can be specified if default options
are not appropriate.

%%%</MODULE>


